<?php

// define('SALT_LENGTH', 4);

/*
Mejor configuracion que constantes
Evita tener que tocar archivos fuente
*/

/**
 * feedo actions.
 *
 * Clase principal del m&oacute;dulo feedo. Cada m&eacute;todo de esta clase es una
 * acci&oacute;n. Cada una enmascara un aspecto de la capa de negocio de la aplicaci&oacute;n.
 * S&oacute;lo se puede acceder a una acci&oacute;n desde el controlador central.
 * Cada acci&oacute;n tiene un template asociado con el html que se mostrar&aacute; al usuario.
 * Este html variar&aacute; en funci&oacute;n de los datos suministrados por la acci&oacute;n.
 * 
 * @package    feedo
 * @subpackage feedo
 * @author     Isaac Rubio de Gabriel
 * @version    SVN: $Id: actions.class.php 12 2008-4-29 1:25:54 isaac $
 */
//require_once(dirname(__FILE__).'/../../../../../lib/generateHash.php');
//require_once(dirname(__FILE__).'/../../../../../lib/generateSalt.php');
require_once(dirname(__FILE__).'/../../../lib/magpie/rss_fetch.inc');

class feedoActions extends sfActions
{
/**
 * 
 * Consulta un archivo yml que dispone de los parametros de la configuracion por defecto.
 * Si dicha configuracion existe en la base de datos se retorna su identificador.
 * De no existir la aade y retorna el nuevo identificador.
 * @return El identificador de la configuracion por defecto
 * 
 */
  private function obtenerConfiguracionPorDefecto()
  {
  	switch(sfConfig::get('app_voice_speed'))
  	{
  	 case 'slow': $speed = 0; break;
  	 case 'normal': $speed = 1; break;
  	 case 'fast': $speed = 2; break;
  	}
  	switch(sfConfig::get('app_voice_man_or_woman'))
  	{
  	 case 'women': $man_or_woman = 0; break;
  	 case 'man': $man_or_woman = 1; break;
  	}
  	
  	$c = new Criteria();
  	$c->add(ConfFeedPeer::VOZ, $man_or_woman);
  	$c->add(ConfFeedPeer::VELOCIDAD_LECTURA, $speed);
  	$c->add(ConfFeedPeer::NUMERO_ENTRADAS, sfConfig::get('app_nbentries'));
  	$conf = ConfFeedPeer::doSelectOne($c);
  	
    if(!$conf)
    {
    	$newConf = new ConfFeed();
    	$newConf->setVoz($man_or_woman);
    	$newConf->setVelocidadLectura($speed);
    	$newConf->setNumeroEntradas(sfConfig::get('app_nbentries'));
    	$newConf->save();
    	return $newConf->getIdConfFeed();
    }
    else
    	return $conf->getIdConfFeed();
  }
  
  private function generateHash($plainText, $salt = null)
  {
	// funcion de encriptacin
	//$config = sfYaml::load(dirname(__FILE__).'/../apps/feedo/config/app.yml');
	//$conf = $config['all']['saltlength'];
    if ($salt === null)
    {	
        $salt = substr(md5(uniqid(rand(), true)), 0, sfConfig::get('app_saltlength'));
    }
    else
    {
        $salt = substr($salt, 0, sfConfig::get('app_saltlength'));
    }

    return $salt . sha1($salt . $plainText);
  }

  private function generateSalt()
  {
	//genera una cadena de caracteres aleatoria de longitud app_salt_length para encriptar las contraseas mediante funciones hash
	//Obtener parmetro de configuracin
	//$config = sfYaml::load(dirname(__FILE__).'/../apps/feedo/config/app.yml');
	//$conf = $config['all']['saltlength'];
    return substr(md5(uniqid(rand(), true)), 0, sfConfig::get('app_saltlength'));
  }

  /**
   *
   *	Si el usuario se encuentra autentificado o tiene activada la opcion de recordar 
   *	constraesnia la accion redirige a un mensaje de bienvenida. En caso contrario muestra 
   *    un mensaje indicando que debe auntentificarse o crear una nueva cuenta. 
   *
   */

  public function executeIndex()
  {	
	if($this->getUser()->isAuthenticated())
	{
		return $this->redirect('feedo/inicio');
	}

	if ($this->getRequest()->getCookie('Feedo'))
	{//si tiene activado la opcion recordar contrasea se loguea directamente
		$value = unserialize(base64_decode($this->getRequest()->getCookie('Feedo')));
		if($value)
		{
			$c = new Criteria();
			$c->add(UsuariosPeer::ID_SESION, $value[0]);
			$c->add(UsuariosPeer::MAIL, $value[1]);
	    	$user = UsuariosPeer::doSelectOne($c);
			if ($user)//si hay un usuario con ese id_sesion y ese mail en la base de datos se loguea
			{
				// sign in
				$this->getContext()->getUser()->signIn($user);
				// proceed to home page
				return $this->redirect('feedo/inicio');
			}
		}
	}
  }
  
  /**
   *
   * Muestra un mensaje de bienvenida.  
   * 
   */
  
  public function executeInicio()
  {//obtiene el mail del usuario de la base de datos
	$id_usuario = $this->getUser()->getAttribute('id_user');
	$this->mail = UsuariosPeer::retrieveByPk($id_usuario)->getMail();
  }
  
  /**
   *
   * Genera un formulario que permite crear una cuenta. 
   *
   */
  
  public function executeFormularioCrearCuenta(){}
  
  /** 
   *
   * Genera un formulario que permite iniciar sesion.
   * 
   */
  
  public function executeFormularioIniciarSesion(){}
  
  /**
   *
   * Comprueba si los datos introducidos pertenecen a una cuenta existente en el sistema.
   * Si asi ocurre se inicia la sesion del usuario. Para ello se crean variables de sesion 
   * necesarias para el funcionamiento de sistema. 
   * 
   */
  
  public function executeIniciarSesion()
  {
	$c = new Criteria();
	$c->add(UsuariosPeer::MAIL, $this->getRequest()->getParameter('correo'));
	$user = UsuariosPeer::doSelectOne($c);
	if($user) //Si hay un usuario con ese mail
	{
		if($this->generateHash($this->getRequest()->getParameter('password'),$user->getSalt()) == $user->getPassword())
		{//si la contrasea introducida y la almacenada coinciden
			//Codigo inicializa sesion
			$remember = $this->getRequestParameter('recordar_password');//obtenemos el valor del checkbox recordar contraseas
			if($user->getAdministrador() && $remember)
				return $this->redirect('feedo/formularioAvisoAdministrador');
			$this->getUser()->signIn($user, $remember);//llamamos a la funcion que loguea al usuario
			if($user->getAdministrador())//si tiene privilegios de administrador
			{
				$this->getUser()->addCredential('admin');// le aadimos credenciales de administrador
			}
			return sfView::SUCCESS;
		}
		else
		{
			return sfView::ERROR;
		}
	}
	else
	{
		return sfView::ERROR;
	}
  }
  
  /**
   *
   * Toma los datos recibidos del formulario y crea una nueva cuenta de usuario en el sistema.
   * Se identificara al usuario mediante una direccion de correo electronico y una contrasenia.
   * Estos datos de usuario se almacenan en la base de datos.
   *
   */
  
  public function executeCrearCuenta()
  {
	$c = new Criteria();
	$c->add(UsuariosPeer::MAIL, $this->getRequest()->getParameter('correo'));
	/*
	WARNING
	El metodo add de la clase criteria genera problemas con las cabeceras
    si no se le pasa el nombre de la columna correctamente
	*/	
	$usuarios = UsuariosPeer::doSelect($c);
    if(!$usuarios)//si NO existen usuarios que utilicen ya el correo creamos la cuenta 
	{
		//Codigo crear cuenta
		$this->newUser = new Usuarios();
		$this->newUser->setMail($this->getRequest()->getParameter('correo'));//establecemos el correo
		$salt = $this->generateSalt();//generamos un salt aleatorio
		$this->newUser->setSalt($salt);//establecemos el salt obtenido
		//establecemos la contrasea, antes la encriptamos con una funcin hash a la que le pasamos el salt obtenido anteriormente  
		$this->newUser->setPassword($this->generateHash($this->getRequest()->getParameter('password'),$salt));
		//establecemos la configuracion general por defecto para los feeds que aada el usuario
		$this->newUser->setIdConfFeed($this->obtenerConfiguracionPorDefecto());//WARNING HARDCODE
		$this->newUser->setCultura($this->getRequest()->getParameter('idioma'));
		$this->newUser->save();//guardamos en la base de datos el nuevo usuario
		//aadimos el usuario a las categorias del sistema
		$id_user = $this->newUser->getIdUsuario();
		$c2 = new Criteria();
		$c2->add(CategoriasPeer::SISTEMA,1);
		$categorias = CategoriasPeer::doSelect($c2);
		foreach($categorias as $value)
		{
			$newCatAdminUsuario = new CatAdminUsuario();
			$newCatAdminUsuario->setIdCategoria($value->getIdCategoria());
			$newCatAdminUsuario->setIdUsuario($id_user);
			$newCatAdminUsuario->save();
		}
		//logueamos al usuario analogamente a la funcion executeIniciarSesin
		$remember = $this->getRequestParameter('recordar_password');
		$this->getUser()->signIn($this->newUser, $remember);
		return sfView::SUCCESS;
	}
	else
	{
		return sfView::ERROR;
	}
  }
  
  /**
   *
   * Genera un mensaje de error en caso de no poder generarse la cuenta de usuario solicitada. 
   *
   */
  
  public function handleErrorCrearCuenta()
  {//regresamos al formulario de crear cuenta para que el usuario pueda subsanar los errores en la informacion suministrada
	$this->forward('feedo','formularioCrearCuenta');
  }
  
  /**
   *
   * Muestra un mensaje de error en caso de no poder iniciarse sesion con los datos introducidos.
   *
   */
  
  public function handleErrorIniciarSesion()
  {//regresamos al formulario de iniciar sesion para que el usuario pueda subsanar los errores en la informacion suministrada
	$this->forward('feedo','formularioIniciarSesion');
  }
  
  /**
   *
   * Cierra la sesion de usuario. Se eleminan todas las variables de sesion necesarias
   * para el funcionamiento de la aplicacion.
   *
   */
  
  public function executeCerrarSesion()
  {//llamamos a la funcin que cierra la sesin signOut
  	$value = unserialize(base64_decode($this->getRequest()->getCookie('Feedo')));
	$this->getUser()->signOut($value);
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera un formulario que permite al usuario cambiar su contrasenia.
   *
   */
  
  public function executeFormularioCambiarContrasenia(){}
  
  /**
   *
   * Toma la nueva contrasenia introducida por el usuario y actualiza la base de datos con ella.
   *
   */
  
  public function executeCambiarContrasenia()
  {//obtenemos los datos del usuario de la base de datos
	$user = UsuariosPeer::retrieveByPk($this->getUser()->getAttribute('id_user'));
	$salt = $this->generateSalt();//generamos aleatoriamente un nuevo salt
	$user->setSalt($salt);//establecemos el nuevo salt
	//establecemos la nueva contrasea encriptandola con el nuevo salt
	$user->setPassword($this->generateHash($this->getRequest()->getParameter('password'),$salt));
	$user->save();//guardamos los cambios en la base de datos
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera un mensaje de error en caso de no poder cambiarse la contrasenia del usuario.
   *
   */
  
  public function handleErrorCambiarContrasenia()
  {////regresamos al formulario de cambiar contrasea para que el usuario pueda subsanar los errores en la informacion suministrada
	$this->forward('feedo','formularioCambiarContrasenia');
  }
  
  /**
   *
   * Almacena en la base de datos la URL de un recurso rss de internet. Este rss estara asociado
   * a una categoria existente en el sistema y a un usuario. 
   *
  */
  
  public function executeAniadirFeed()
  {//incluimos la librerias del magpie
	if(!fetch_rss($this->getRequest()->getParameter('RSSchannel')))
	{//si el canal RSS no est disponible generamos un error
		return sfView::ERROR;
	}
	$c = new Criteria();
	$c->add(FeedsPeer::URL, $this->getRequest()->getParameter('RSSchannel'));
	$feeds = FeedsPeer::doSelectOne($c);
	if(!$feeds)//si no existe esa url en la base de datos 
	{
		$this->newFeed = new Feeds();
		$this->newFeed->setUrl($this->getRequest()->getParameter('RSSchannel'));//establecemos la url dada por el usuario
		$this->newFeed->save();//guardamos la informacion en la base de datos
		$feeds = FeedsPeer::doSelectOne($c);//inicializamos la variable $feeds con el nuevo feed
	}
	//si la url ya existe en la base de datos realizamos una consulta para para inicializar $feeds con el feed almacenado
	//De la variable $feeds obtendremos el identificador con el que actualizar la talbla FeedsSistema que mantiene la relacion entre feeds, usuarios, categorias y configuracion
	//obtenemos la configuracin del usuario
	$conf = UsuariosPeer::retrieveByPk($this->getUser()->getAttribute('id_user'))->getIdConfFeed();
	//creo un nuevo feed
	$this->newFeedSistema = new FeedsSistema();
	$this->newFeedSistema->setUsuariosId($this->getUser()->getAttribute('id_user'));//establecemos el identificador de usuario
	$this->newFeedSistema->setFeedsId($feeds->getIdFeed());//establecemos el identificador de feed
	$this->newFeedSistema->setCategoriasId($this->getRequest()->getParameter('categorias'));//establecemos el identificador de la categoria
	$this->newFeedSistema->setConfFeedId($conf);
	$this->newFeedSistema->save();//guardo los datos en la base de datos
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera un formulario que permite al usuario introducir la URL del feed que desea sindicar
   * en su cuenta y elegir la categoria donde quiere colocarlo.
   * 
   */
  
  public function executeFormularioAniadirFeed()
  {//realizo una consulta para obtener las categorias del sistema y del usuario. Serviran para generar un select con el que el usuario elegira la categoria en que desea encuadrar al feed
	$c = new Criteria();
	$c->addJoin(CategoriasPeer::ID_CATEGORIA, CatAdminUsuarioPeer::ID_CATEGORIA);
	$c->add(CatAdminUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
	$categorias = CategoriasPeer::doSelect($c);
	if($categorias){
		foreach($categorias as $value)//preparamos un vector al que accederemos en el template para obtener las categorias
		{
			$aux[$value->getIdCategoria()] = $value->getDescripcion();
		}
	}
	else $aux[-1] = 'El usuario no tiene ninguna categor&iacute;a';
	$this->cat = $aux;
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Muestra con sus titulares todos los feeds asociados a un usuario y a una categoria.
   *
   */
  
  public function executeImprimirFeed()
  {//obtenemos los feeds asociados al usuario y la categoria 
	$c = new Criteria();
	$c->add(FeedsSistemaPeer::CATEGORIAS_ID, $this->getRequest()->getParameter('categoria'));
	$c->add(FeedsSistemaPeer::USUARIOS_ID, $this->getUser()->getAttribute('id_user'));
	$this->feeds = FeedsSistemaPeer::doSelect($c);
	if(!$this->feeds)
	{
		return sfView::ERROR;
	}
	else{
		$this->getUser()->setAttribute('feeds',$this->feeds);
		return sfView::SUCCESS;
		}
  }
   
  /**
   *
   * Genera un formulario que permite al usuario aniadir una categoria a su cuenta.
   *
   */
  
  public function executeFormularioAniadirCategoria(){}
  
  /**
   *
   * Almacena en la base de datos la nueva categoria introducida por el usuario.
   *
   */
  
  public function executeAniadirCategoria()
  {//aade a la tabla categorias la categoria indicada por el usuario
	$this->newCategory = new Categorias();
	$this->newCategory->setDescripcion($this->getRequest()->getParameter('category'));//establecemos la categoria
	$this->newCategory->save();//guardamos la informacion en la base de datos
	$id_cat = $this->newCategory->getIdCategoria();
	$this->newCatAdminUsuario = new CatAdminUsuario();
	$this->newCatAdminUsuario->setIdUsuario($this->getUser()->getAttribute('id_user'));
	$this->newCatAdminUsuario->setIdCategoria($id_cat);
	$this->newCatAdminUsuario->save();
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera una lista que permite al usuario seleccionar la categoria de su cuenta
   * que desea borrar.
   *
   */
  
  public function executeFormularioBorrarCategoria()
  {
	$c = new Criteria();
	$c->add(CatAdminUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
	$c->addJoin(CatAdminUsuarioPeer::ID_CATEGORIA, CategoriasPeer::ID_CATEGORIA);
	$categorias = CategoriasPeer::doSelect($c);
	if($categorias){
		foreach($categorias as $value)//preparamos un vector al que accederemos en el template para obtener las categorias
		{
			$aux[$value->getIdCategoria()] = $value->getDescripcion();
		}
	}
	else $aux[-1] = 'El usuario no tiene ninguna categor&iacute;a'; 
	$this->cat = $aux;
	return sfView::SUCCESS;
  }

  
  /**
   *
   * Genera un mensaje para obtener del usuario una conformacion de borrado. Ya que si se borra 
   * una categoria se borraran todos los feeds que el usuario tiene en esa categoria.
   *
   */
  
  public function executePreguntarBorrarCategoria()
  {
	$this->cat = $this->getRequest()->getParameter('categoria');
	if($this->cat == -1) return $this->redirect('');
  }
  
  /**
   *
   * Se eleminan de la base  de datos la categoria y todos los feeds que contenia.
   *
   */
  
  public function executeBorrarCategoria()
  {//borramos todos los feeds asociados a la categoria
	if($this->getRequest()->getParameter('respuesta') == 'si')
	{
		$id_cat = $this->getRequest()->getParameter('categoria');
		$id_user = $this->getUser()->getAttribute('id_user');
		$c = new Criteria();
		$c->add(FeedsSistemaPeer::CATEGORIAS_ID, $id_cat);
		$c->add(FeedsSistemaPeer::USUARIOS_ID, $id_cat);
		$fs = FeedsSistemaPeer::doSelect($c);
		foreach($fs as $value)
			$value->delete();
		$categoria = CategoriasPeer::retrieveByPk($id_cat);
		$catAdminUsuario = CatAdminUsuarioPeer::retrieveByPk($id_cat, $id_user);
		$catAdminUsuario->delete();
		if($categoria->getSistema() ==  0)
			$categoria->delete();
		return sfView::SUCCESS;
	}
	else
	{
	$this->redirect('feedo/formularioBorrarCategoria');
	}
  }
  
  
  /**
   *
   * Genera un formulario que permite al usuario configurar varios aspectos del feed.
   *
   */
  
  public function executeFormularioConfiguracionFeed()
  {
	$this->id_feed = $this->getRequest()->getParameter('id_feed');
	$this->id_cat = $this->getRequest()->getParameter('id_cat');
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera un formulario que permite al usuario determinar la configuracion inicial de los
   * feeds que se aniaden a su cuenta.
   *
   */
  
  public function executeFormularioConfiguracionGeneral(){}
  
  /**
   *
   * Actualiza en la base de datos los nuevos parametros de configuracion del feed 
   * introducidos por el usuario.
   *
   */
  
  public function executeConfiguracionFeed()
  {
	$c = new Criteria();
	$c->add(ConfFeedPeer::VOZ,$this->getRequest()->getParameter('voice'));
	$c->add(ConfFeedPeer::VELOCIDAD_LECTURA,$this->getRequest()->getParameter('speed'));
	$c->add(ConfFeedPeer::NUMERO_ENTRADAS,$this->getRequest()->getParameter('nbEntries'));
	$configuration = ConfFeedPeer::doSelectOne($c);
	
	if(!$configuration)//si la configuracion NO existe en la base de datos la agrego
	{
		$configuration = new ConfFeed();
		$configuration->setVoz($this->getRequest()->getParameter('voice'));
		$configuration->setVelocidadLectura($this->getRequest()->getParameter('speed'));
		$configuration->setNumeroEntradas($this->getRequest()->getParameter('nbEntries'));
		$configuration->save();
	}
	//actualizo en FeedSistema tabla que relaciona feeds, usuarios y categorias la configuracion
	$fs = FeedsSistemaPeer::retrieveByPk($this->getUser()->getAttribute('id_user'),
											$this->getRequest()->getParameter('id_cat'),
											$this->getRequest()->getParameter('id_feed'));
	$fs->setConfFeedId($configuration->getIdConfFeed());
	$fs->save();
  }
  
  /**
   *
   * Actualiza en la base de datos los nuevos parametros de configuracion introducidos 
   * por el usuario para los nuevos feeds que se agreguen en su cuenta.
   * 
   */
  
  public function executeConfiguracionGeneral()
  {
	$c = new Criteria();
	$c->add(ConfFeedPeer::VOZ,$this->getRequest()->getParameter('voice'));
	$c->add(ConfFeedPeer::VELOCIDAD_LECTURA,$this->getRequest()->getParameter('speed'));
	$c->add(ConfFeedPeer::NUMERO_ENTRADAS,$this->getRequest()->getParameter('nbEntries'));
	$configuration = ConfFeedPeer::doSelectOne($c);
	if(!$configuration)//si la configuracion NO existe en la base de datos la agrego 
	{
		$configuration = new ConfFeed();
		$configuration->setVoz($this->getRequest()->getParameter('voice'));
		$configuration->setVelocidadLectura($this->getRequest()->getParameter('speed'));
		$configuration->setNumeroEntradas($this->getRequest()->getParameter('nbEntries'));
		$configuration->save();
	}
	$user = UsuariosPeer::retrieveByPk($this->getUser()->getAttribute('id_user'));
	$id_conf_feed_aux = $user->getIdConfFeed();//guardo la configuarcion actual del usuario
	$user->setIdConfFeed($configuration->getIdConfFeed());//establezco la nueva
	$user->save();//guardo los cambios en al tabla usuarios
	$c1 = new Criteria();//obtnego los feeds asociados la usuario
	$c1->add(FeedsSistemaPeer::USUARIOS_ID,$this->getUser()->getAttribute('id_user'));
	$fs = FeedsSistemaPeer::doSelect($c1);
	foreach($fs as $value)//los que se mantenian con la configuracion general los actualizo a la configuracion general del usuario
	{
		if($value->getConfFeedId() == $id_conf_feed_aux)
		{
			$value->setConfFeedId($configuration->getIdConfFeed());//establezco la nueva configuracion para el feed
			$value->save();//guardo los cambios en la base de datos
		}
	}
  }
  
  /**
   *
   * Genera un formulario que solicita confirmacion del usuario para borrar un feed.
   * 
   */
  
  public function executeFormularioBorrarFeed()
  {
	$this->id_feed = $this->getRequest()->getParameter('id_feed');
	$this->id_cat = $this->getRequest()->getParameter('id_cat');
	return sfView::SUCCESS;
  }

  /**
   *
   * Borra de la tabla de la base de datos que relaciona feeds y usuarios la entrada
   * correspondiente al usuario actual y al feed solicitado. En caso de no estar asociado
   * a ningun otro usuario tambien se elemina la entrada de la tabla feeds.
   *
   */
  
  public function executeBorrarFeed()
  {//obtenemos la fila de FeedSistema donde se establece la relacion del usuario con el feed
		$fs = FeedsSistemaPeer::retrieveByPk($this->getUser()->getAttribute('id_user'),
											$this->getRequest()->getParameter('id_cat'),
											$this->getRequest()->getParameter('id_feed'));
		$fs->delete();//borramos la fila
		$c = new Criteria();
		$c->add(FeedsSistemaPeer::FEEDS_ID, $this->getRequest()->getParameter('id_feed'));
		$feeds = FeedsSistemaPeer::doSelect($c);
		$f = FeedsPeer::retrieveByPk($this->getRequest()->getParameter('id_feed'));
		if(!$feeds && ($f->getRecomendado() == 0))//si ningun usuario mas agrego ese feed y no esta recomendado lo borramos del sistema
		{
			$f->delete();
		}
		return sfView::SUCCESS;
  }
  
  /**
   *
   * Genera un formulario que permite al usuario elegir entre una oferta de feeds recomendados
   * por el administrador de la aplicacion.
   *
   */
  
  public function executeFormularioFeedsRecomendados()
  {
	$c = new Criteria();
	$c->add(FeedsPeer::RECOMENDADO, 1);
	$fr = FeedsPeer::doSelect($c);//obtenemos los feeds con el campo recomendado a 1
	if(!$fr) return sfView::ERROR;
    //preparamos el vector de feeds
	foreach($fr as $value)
	{
		if($value->isAvailable())
			$aux2[$value->getIdFeed()] = $value->getTitle();
	}
	$this->recomendados = $aux2;
	$c2 = new Criteria();
	$c2->addJoin(CategoriasPeer::ID_CATEGORIA, CatAdminUsuarioPeer::ID_CATEGORIA);
	$c2->add(CatAdminUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
	$categorias = CategoriasPeer::doSelect($c);
	if($categorias){
		foreach($categorias as $value)//preparamos un vector al que accederemos en el template para obtener las categorias
		{
			$aux[$value->getIdCategoria()] = $value->getDescripcion();
		}
	}
	else $aux[-1] = 'El usuario no tiene ninguna categor&iacute;a';
	$this->cat = $aux;
	return sfView::SUCCESS; 
  }
  
  /**
   *
   * Aniade a la cuenta de usuario el feed recomendado elegido por este. Se estable en la base
   * de datos la relacion entre el feed, ya existente, y el usuario.
   *
   */
  
  public function executeFeedsRecomendados()
  {
	$newfs = new FeedsSistema();//adimos una fila a FeedsSistema, tabla que relaciona usuarios, categorias y feeds
	$newfs->setCategoriasId($this->getRequest()->getParameter('id_cat'));
	$newfs->setFeedsId($this->getRequest()->getParameter('id_feed'));
	$newfs->setUsuariosId($this->getUser()->getAttribute('id_user'));
	$newfs->setConfFeedId(UsuariosPeer::retrieveByPk($this->getUser()->getAttribute('id_user'))->getIdConfFeed());
	$newfs->save();
	return sfView::SUCCESS;
  }
  
  /**
   *
   * Cambia la cultura asociada al usuario. Dicha cultura indica entre otras cosas el idioma
   * en el que se mostraran los contenidos al usuario.
   *
   */
  
  public function executeCambiarIdioma()
  {//cambia la cultura del usuario
	$cultura = $this->getRequest()->getParameter('idioma');
	$this->getUser()->setCulture($cultura);
	if($this->getUser()->isAuthenticated())
	{
		$user = UsuariosPeer::retrieveByPk($this->getUser()->getAttribute('id_user'));
		$user->setCultura($cultura);
		$user->save();
	}	
	
	//Regresar al punto anterior
	$src = $this->getRequest()->getReferer();
	$this->redirect($src);
  }
  
  /**
   *
   * Guarda en la base de datos una URL externa a la aplicacion. Esto permite indicar al
   * usuario que titulares de los feeds ha visitado.
   * 
   */
  
  public function executeVisitarUrl()
  {
	$this->name = $this->getRequest()->getParameter('name');
	$feed = $this->getRequest()->getParameter('feed');
	$feeds = $this->getUser()->getAttribute('feeds');
	$size = sizeof($feeds);
	$this->url = 'feedo/inicio';
	//buscamos la url del item
	$i = 0;
	while($i < $size && $feeds[$i]->getTitle() != $feed)
		$i++;
	if($i >= $size)
		return sfView::ERROR;
	else
	{
		$items = $feeds[$i]->getItems();
		foreach($items as $key => $item)
			if($item == $this->name) $this->url = $key;
	}
	//borramos la variable de sesion
	$this->getUser()->getAttributeHolder()->remove('feed');
	//modificamos la base de datos para apuntar la url como visitada
	$c = new Criteria();
	$c->add(UrlVisitadasPeer::URL, $this->url);
	$url_visitadas = UrlVisitadasPeer::doSelectOne($c);
	if(!$url_visitadas)//si la url no esta en la base de datos la aadimos
	{
		$newUrlVisitadas = new UrlVisitadas();
		$newUrlVisitadas->setUrl($this->url);
		$newUrlVisitadas->save();
		$id_url_visitadas = $newUrlVisitadas->getIdUrl();
	}
	else	
		$id_url_visitadas = $url_visitadas->getIdUrl();
		
	$url_visitadas_usuario = UrlVisitadasUsuarioPeer::retrieveByPk($id_url_visitadas, 
							$this->getUser()->getAttribute('id_user'));
	if(!$url_visitadas_usuario)//si el usuario no visito la url lo anotamos
	{
		//si el usuario tiene 200 sobreescribimos la mas vieja
		//consulta 200 url_visitadas
		$c1 = new Criteria();
		$c1->add(UrlVisitadasUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
		$uv = UrlVisitadasUsuarioPeer::doSelect($c1);
		$nbuv = count($uv);
		if($nbuv >= sfConfig::get('app_visitedurlnumber'))//si ya tiene 200 eliminamos las mas vieja
		{
			// $c = new Criteria();
			// $c->add(UrlVisitadasUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
			$c1->addAscendingOrderByColumn(UrlVisitadasUsuarioPeer::ID_URL);
			$uv = UrlVisitadasUsuarioPeer::doSelectOne($c1);
			$uv->delete();
		}
		$newUrlVisitadasUsuario = new UrlVisitadasUsuario();
		$newUrlVisitadasUsuario->setIdUrl($id_url_visitadas);
		$newUrlVisitadasUsuario->setIdUsuario($this->getUser()->getAttribute('id_user'));
		$newUrlVisitadasUsuario->save();
	} 
	return sfView::SUCCESS;
  }
  
/**
 * 
 * Genera un mensaje de aviso si el administrador intenta recordar su contrasenia
 * 
 */
  public function executeFormularioAvisoAdministrador(){}
  
}


