<?php


abstract class BaseCatFeedsRecomendados extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_feed = 0;


	
	protected $id_categoria = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdFeed()
	{

		return $this->id_feed;
	}

	
	public function getIdCategoria()
	{

		return $this->id_categoria;
	}

	
	public function setIdFeed($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_feed !== $v || $v === 0) {
			$this->id_feed = $v;
			$this->modifiedColumns[] = CatFeedsRecomendadosPeer::ID_FEED;
		}

	} 
	
	public function setIdCategoria($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_categoria !== $v || $v === 0) {
			$this->id_categoria = $v;
			$this->modifiedColumns[] = CatFeedsRecomendadosPeer::ID_CATEGORIA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_feed = $rs->getInt($startcol + 0);

			$this->id_categoria = $rs->getInt($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CatFeedsRecomendados object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CatFeedsRecomendadosPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CatFeedsRecomendadosPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CatFeedsRecomendadosPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CatFeedsRecomendadosPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += CatFeedsRecomendadosPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CatFeedsRecomendadosPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CatFeedsRecomendadosPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdFeed();
				break;
			case 1:
				return $this->getIdCategoria();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CatFeedsRecomendadosPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdFeed(),
			$keys[1] => $this->getIdCategoria(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CatFeedsRecomendadosPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdFeed($value);
				break;
			case 1:
				$this->setIdCategoria($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CatFeedsRecomendadosPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdFeed($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdCategoria($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CatFeedsRecomendadosPeer::DATABASE_NAME);

		if ($this->isColumnModified(CatFeedsRecomendadosPeer::ID_FEED)) $criteria->add(CatFeedsRecomendadosPeer::ID_FEED, $this->id_feed);
		if ($this->isColumnModified(CatFeedsRecomendadosPeer::ID_CATEGORIA)) $criteria->add(CatFeedsRecomendadosPeer::ID_CATEGORIA, $this->id_categoria);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CatFeedsRecomendadosPeer::DATABASE_NAME);

		$criteria->add(CatFeedsRecomendadosPeer::ID_FEED, $this->id_feed);
		$criteria->add(CatFeedsRecomendadosPeer::ID_CATEGORIA, $this->id_categoria);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getIdFeed();

		$pks[1] = $this->getIdCategoria();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setIdFeed($keys[0]);

		$this->setIdCategoria($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{


		$copyObj->setNew(true);

		$copyObj->setIdFeed('null'); 
		$copyObj->setIdCategoria('null'); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CatFeedsRecomendadosPeer();
		}
		return self::$peer;
	}

} 