<?php


abstract class BaseConfFeed extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id_conf_feed;


	
	protected $voz = 0;


	
	protected $velocidad_lectura = 0;


	
	protected $numero_entradas = 0;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getIdConfFeed()
	{

		return $this->id_conf_feed;
	}

	
	public function getVoz()
	{

		return $this->voz;
	}

	
	public function getVelocidadLectura()
	{

		return $this->velocidad_lectura;
	}

	
	public function getNumeroEntradas()
	{

		return $this->numero_entradas;
	}

	
	public function setIdConfFeed($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_conf_feed !== $v) {
			$this->id_conf_feed = $v;
			$this->modifiedColumns[] = ConfFeedPeer::ID_CONF_FEED;
		}

	} 
	
	public function setVoz($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->voz !== $v || $v === 0) {
			$this->voz = $v;
			$this->modifiedColumns[] = ConfFeedPeer::VOZ;
		}

	} 
	
	public function setVelocidadLectura($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->velocidad_lectura !== $v || $v === 0) {
			$this->velocidad_lectura = $v;
			$this->modifiedColumns[] = ConfFeedPeer::VELOCIDAD_LECTURA;
		}

	} 
	
	public function setNumeroEntradas($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->numero_entradas !== $v || $v === 0) {
			$this->numero_entradas = $v;
			$this->modifiedColumns[] = ConfFeedPeer::NUMERO_ENTRADAS;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id_conf_feed = $rs->getInt($startcol + 0);

			$this->voz = $rs->getInt($startcol + 1);

			$this->velocidad_lectura = $rs->getInt($startcol + 2);

			$this->numero_entradas = $rs->getInt($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ConfFeed object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConfFeedPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ConfFeedPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ConfFeedPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ConfFeedPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setIdConfFeed($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ConfFeedPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ConfFeedPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConfFeedPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getIdConfFeed();
				break;
			case 1:
				return $this->getVoz();
				break;
			case 2:
				return $this->getVelocidadLectura();
				break;
			case 3:
				return $this->getNumeroEntradas();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConfFeedPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getIdConfFeed(),
			$keys[1] => $this->getVoz(),
			$keys[2] => $this->getVelocidadLectura(),
			$keys[3] => $this->getNumeroEntradas(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ConfFeedPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setIdConfFeed($value);
				break;
			case 1:
				$this->setVoz($value);
				break;
			case 2:
				$this->setVelocidadLectura($value);
				break;
			case 3:
				$this->setNumeroEntradas($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ConfFeedPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setIdConfFeed($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setVoz($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setVelocidadLectura($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNumeroEntradas($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ConfFeedPeer::DATABASE_NAME);

		if ($this->isColumnModified(ConfFeedPeer::ID_CONF_FEED)) $criteria->add(ConfFeedPeer::ID_CONF_FEED, $this->id_conf_feed);
		if ($this->isColumnModified(ConfFeedPeer::VOZ)) $criteria->add(ConfFeedPeer::VOZ, $this->voz);
		if ($this->isColumnModified(ConfFeedPeer::VELOCIDAD_LECTURA)) $criteria->add(ConfFeedPeer::VELOCIDAD_LECTURA, $this->velocidad_lectura);
		if ($this->isColumnModified(ConfFeedPeer::NUMERO_ENTRADAS)) $criteria->add(ConfFeedPeer::NUMERO_ENTRADAS, $this->numero_entradas);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ConfFeedPeer::DATABASE_NAME);

		$criteria->add(ConfFeedPeer::ID_CONF_FEED, $this->id_conf_feed);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getIdConfFeed();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setIdConfFeed($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setVoz($this->voz);

		$copyObj->setVelocidadLectura($this->velocidad_lectura);

		$copyObj->setNumeroEntradas($this->numero_entradas);


		$copyObj->setNew(true);

		$copyObj->setIdConfFeed(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ConfFeedPeer();
		}
		return self::$peer;
	}

} 